/*#############################################################################
# VIDEO.H
#
# Autor  : Zoran M.Todorovic
# Datum  : Maj '94
#
# Verzija: 2.10
#
# Definicije konstanti i varijabli potrebnih za rad sa bibliotekom TRIX
#############################################################################*/

#ifndef __VIDEO_H__
#define __VIDEO_H__

#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

enum borderId { bidNoBorder, bidSingleBorder, bidDoubleBorder, bidFullBorder };

uint InitVideo(void);
void CursorWhere(int *col, int *row);
void CursorGoto(int col, int row);
void PlaceChar(int, int, char);
void PlaceCharAttr(int, int, char, char);
void PlaceAttr(int, int, char);
void RepeatChar(int, int, int, char);
void RepeatCharAttr(int, int, int, char, char);
void PutStrg(int, int, char *);
void PutPartStrg(int, int, int, int, char *);
void PutStrgTrail(int, int, int, char *);
void PutStrgAttr(int, int, char, char *);
void PutPartStrgAttr(int, int, int, int, char, char *);
void PutStrgTrailAttr(int, int, int, char, char *);
void PutAttr(int, int, char, char);
void CenterStrg(int, int, int, char *);
void CenterStrgAttr(int, int, int, char, char *);
void BoxFill(int, int, int, int, char);
void BoxFillAttr(int, int, int, int, char, char);
void BoxAttr(int, int, int, int, char);
void BorderChar(int, int, int, int, char *);
void BorderCharAttr(int, int, int, int, char, char *);
void BorderAttr(int, int, int, int, char);
void HorizontalLine(int, int, int, int);
void VerticalLine(int, int, int, int);
char GetChar(int, int);
char GetAttr(int, int);
void GetCharAttr(int, int, char *, char *);
void GetCharArea(int, int, int, int, char *);
void GetCharAttrArea(int, int, int, int, char *);
void PutCharArea(int, int, int, int, char *);
void PutCharAttrArea(int, int, int, int, char *);
void ScrollUp(int, int, int, int, int);
void ScrollDown(int, int, int, int, int);

#ifdef __cplusplus
}
#endif

#endif

/*#############################################################################
# Kraj datoteke VIDEO.H
#############################################################################*/

