/*#############################################################################
# IPXCHECK32DLG.CPP
#
# SCA Software International S.A.
#
#############################################################################*/

#include "stdafx.h"
#include "IpxCheck32.h"
#include "IpxCheck32Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MSG_WINSOCK       WM_USER+10

struct TPacket {
  char Name[64];
  short Day;
  short Month;
  short Year;
  short Hour;
  short Minute;
  short Second;

  TPacket()
  {
    ::ZeroMemory(Name,sizeof(Name));
    Day = Month = Year = 0;
    Hour = Minute = Second = 0;
  }
};

//=============================================================================
// TIpxCheck32Dlg dialog
//
//=============================================================================

BEGIN_MESSAGE_MAP(TIpxCheck32Dlg, CDialog)
	//{{AFX_MSG_MAP(TIpxCheck32Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
  ON_MESSAGE(MSG_WINSOCK, OnWinsock)
	ON_EN_KILLFOCUS(IDC_NAME, OnNameExit)
	ON_EN_SETFOCUS(IDC_NAME, OnNameEnter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

TIpxCheck32Dlg::TIpxCheck32Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(TIpxCheck32Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(TIpxCheck32Dlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_bIpxSupported = FALSE;
}

void TIpxCheck32Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TIpxCheck32Dlg)
	DDX_Control(pDX, IDC_NAME, NameEd);
	DDX_Control(pDX, IDC_STATION_LIST, StationL);
	//}}AFX_DATA_MAP
}

BOOL TIpxCheck32Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  StationL.SetExtendedStyle(LVS_EX_FULLROWSELECT);

  StationL.InsertColumn(0,"Node address", LVCFMT_LEFT, 110);
  StationL.InsertColumn(1,"Computer name", LVCFMT_LEFT, 150);
  StationL.InsertColumn(2,"Timestamp", LVCFMT_LEFT, 120);

  //IconList.Create(IDB_COMMICON, 16, 1, (COLORREF)-1 ); 
  //NetL.SetImageList(&IconList, LVSIL_SMALL);

  if (!m_bIpxSupported) {
    StationL.EnableWindow(FALSE);
    NameEd.EnableWindow(FALSE);
    AfxMessageBox("IPX protocol is not installed on this machine !");
  } else {
    NameEd.SetWindowText(m_strHostName);
    SetTimer(100,1000,NULL);
  }
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void TIpxCheck32Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR TIpxCheck32Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void TIpxCheck32Dlg::OnNameExit() 
{
  CString str;
  NameEd.GetWindowText(str);
  if (!str.IsEmpty()) {
    m_strHostName = str;
  }
  NameEd.SetReadOnly(TRUE);
}

void TIpxCheck32Dlg::OnNameEnter() 
{
  NameEd.SetReadOnly(FALSE);
}

void TIpxCheck32Dlg::AtoH(char *src, char *dest, int destlen)
{
  char *srcptr = src;
  while(destlen--) {
    *dest = BtoH(*srcptr++) << 4;    // Put 1st ascii byte in upper nibble.
    *dest++ += BtoH(*srcptr++);      // Add 2nd ascii byte to above.
  }
}

unsigned char TIpxCheck32Dlg::BtoH(char ch)
{
  if (ch >= '0' && ch <= '9') return (ch - '0');
  if (ch >= 'A' && ch <= 'F') return (ch - 'A' + 0xA);
  if (ch >= 'a' && ch <= 'f') return (ch - 'a' + 0xA);
  return(255);
}

void TIpxCheck32Dlg::createAddress(SOCKADDR *pAddress, LPCTSTR szNetwork, LPCTSTR szNode,
                                   LPCTSTR szSocket)
{
  SOCKADDR_IPX addr;
  ::ZeroMemory(&addr,sizeof(SOCKADDR_IPX));
  if (szNetwork)
    AtoH((char*)szNetwork, (char*)&addr.sa_netnum, 4);    // Network order
  if (szNode)
    AtoH((char*)szNode, (char*)&addr.sa_nodenum, 6);      // Network order
  if (szSocket)
    AtoH((char*)szSocket, (char *)&addr.sa_socket, 2);  // Network order                  
  addr.sa_family = AF_IPX;                            // IPX Family
  CopyMemory(pAddress,&addr,sizeof(SOCKADDR_IPX));
}

int TIpxCheck32Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

  WSAData data;
  WORD wVersion = MAKEWORD(2,0);
  int retcode = ::WSAStartup(wVersion,&data);
  if (retcode != 0) {
    TRACE0("Winsock 2 not supported on this machine\n");
    return -1;
  }

  createAddress(&m_Address, "00000000","FFFFFFFFFFFF","5050");

  m_hSocket = ::socket(AF_IPX,SOCK_DGRAM,NSPROTO_IPX);
  if (m_hSocket == INVALID_SOCKET) {
    if (GetLastError() == WSAEAFNOSUPPORT) {
      TRACE0("IPX protocol not supported on this machine\n");
    }
    return -1;
  }
  
  m_bIpxSupported = TRUE;
  BOOL flag = TRUE;
  ::setsockopt(m_hSocket, SOL_SOCKET, SO_BROADCAST, (char*)&flag, sizeof(BOOL));
  ::WSAAsyncSelect(m_hSocket, m_hWnd, MSG_WINSOCK, FD_READ);
  ::bind(m_hSocket, &m_Address, sizeof(SOCKADDR));

  CHAR cName[MAX_COMPUTERNAME_LENGTH + 1];
  DWORD dwNameLen = sizeof(cName);
  ::GetComputerName(cName, &dwNameLen);
  m_strHostName = cName;
  return 0;
}

void TIpxCheck32Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
  ::closesocket(m_hSocket);
  ::WSACleanup();
}

LRESULT TIpxCheck32Dlg::OnWinsock(WPARAM wParam, LPARAM lParam)
{
  // Receive from station
  char buffer[128];
  int bytes = 0;
  
  SOCKADDR addrfrom;
  int addrfromlen = sizeof(SOCKADDR);

  ::recvfrom(m_hSocket, buffer, sizeof(buffer),0, &addrfrom, &addrfromlen);
  // Insert or update list view
  updateList(&addrfrom,buffer,bytes);
  return 0;
}

void TIpxCheck32Dlg::updateList(SOCKADDR *pAddrFrom, char *buffer, int buflen)
{
  TPacket *packet = (TPacket*)buffer;
  CString node = formatNodeAddress(pAddrFrom);
  int index;
  LVFINDINFO fi;
  fi.psz = (LPCTSTR)node;
  fi.flags = LVFI_STRING;
  index = StationL.FindItem(&fi);
  if (index == -1) {
    index = StationL.GetItemCount();
    StationL.InsertItem(index, node);
  }
  CString name = packet->Name;
  if (m_strHostName == name)
    name += " (local)";
  StationL.SetItemText(index,1, name);
  CString str;
  str.Format("%02d.%02d.%04d %02d:%02d:%02d",
              packet->Day, packet->Month, packet->Year,
              packet->Hour, packet->Minute, packet->Second);
  StationL.SetItemText(index,2,str);
}

CString TIpxCheck32Dlg::formatNodeAddress(SOCKADDR *pAddrFrom)
{
  CString str, tmp;
  SOCKADDR_IPX addr;
  ::CopyMemory(&addr,pAddrFrom,sizeof(SOCKADDR_IPX));
  tmp.Format("%02X%02X%02X%02X%02X%02X",
              (BYTE)addr.sa_nodenum[0],(BYTE)addr.sa_nodenum[1],
              (BYTE)addr.sa_nodenum[2],(BYTE)addr.sa_nodenum[3],
              (BYTE)addr.sa_nodenum[4],(BYTE)addr.sa_nodenum[5]);
  str.Format("%c%c:%c%c:%c%c:%c%c:%c%c:%c%c",
              tmp[0],tmp[1],tmp[2],tmp[3],tmp[4],tmp[5],
              tmp[6],tmp[7],tmp[8],tmp[9],tmp[10],tmp[11]);
  return str;
}

void TIpxCheck32Dlg::OnTimer(UINT nIDEvent) 
{
  int bytes = 0;
  SYSTEMTIME lt;
  TPacket packet;
  ::GetLocalTime(&lt);
  strcpy(packet.Name,m_strHostName);
  packet.Day = lt.wDay;
  packet.Month = lt.wMonth;
  packet.Year = lt.wYear;
  packet.Hour = lt.wHour;
  packet.Minute = lt.wMinute;
  packet.Second = lt.wSecond;
  ::sendto(m_hSocket,(char*)&packet,sizeof(TPacket),0,&m_Address, sizeof(SOCKADDR));
}

/*#############################################################################
# End of file IPXCHECK32DLG.CPP
#############################################################################*/
